{
  This file was automatically generated on 2012-07-25.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickMaster;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE = 1;
  BRICK_MASTER_FUNCTION_GET_STACK_CURRENT = 2;
  BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE = 3;
  BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE = 4;
  BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT = 5;
  BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS = 6;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS = 7;
  BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS = 8;
  BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS = 9;
  BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS = 10;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS = 11;
  BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH = 12;
  BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG = 13;
  BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY = 14;
  BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY = 15;
  BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL = 16;
  BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL = 17;
  BRICK_MASTER_FUNCTION_IS_RS485_PRESENT = 18;
  BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS = 19;
  BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS = 20;
  BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS = 21;
  BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS = 22;
  BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG = 23;
  BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION = 24;
  BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION = 25;
  BRICK_MASTER_FUNCTION_RESET = 243;
  BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE = 242;

type
  TBrickMaster = class(TDevice)
  private
  public
    constructor Create(const uid_: string);
    function GetStackVoltage: word; virtual;
    function GetStackCurrent: word; virtual;
    procedure SetExtensionType(const extension: byte; const exttype: longword); virtual;
    function GetExtensionType(const extension: byte): longword; virtual;
    function IsChibiPresent: boolean; virtual;
    procedure SetChibiAddress(const address: byte); virtual;
    function GetChibiAddress: byte; virtual;
    procedure SetChibiMasterAddress(const address: byte); virtual;
    function GetChibiMasterAddress: byte; virtual;
    procedure SetChibiSlaveAddress(const num: byte; const address: byte); virtual;
    function GetChibiSlaveAddress(const num: byte): byte; virtual;
    function GetChibiSignalStrength: byte; virtual;
    procedure GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word); virtual;
    procedure SetChibiFrequency(const frequency: byte); virtual;
    function GetChibiFrequency: byte; virtual;
    procedure SetChibiChannel(const channel: byte); virtual;
    function GetChibiChannel: byte; virtual;
    function IsRS485Present: boolean; virtual;
    procedure SetRS485Address(const address: byte); virtual;
    function GetRS485Address: byte; virtual;
    procedure SetRS485SlaveAddress(const num: byte; const address: byte); virtual;
    function GetRS485SlaveAddress(const num: byte): byte; virtual;
    function GetRS485ErrorLog: word; virtual;
    procedure SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte); virtual;
    procedure GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte); virtual;
    procedure Reset; virtual;
    function GetChipTemperature: smallint; virtual;
  end;

implementation

constructor TBrickMaster.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Master Brick';
  bindingVersion[0] := 1;
  bindingVersion[1] := 2;
  bindingVersion[2] := 1;
end;

function TBrickMaster.GetStackVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickMaster.GetStackCurrent: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_STACK_CURRENT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetExtensionType(const extension: byte; const exttype: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_EXTENSION_TYPE, 9);
  LEConvertUInt8To(extension, 4, request);
  LEConvertUInt32To(exttype, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetExtensionType(const extension: byte): longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, 5);
  LEConvertUInt8To(extension, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_EXTENSION_TYPE, response);
  result := LEConvertUInt32From(4, response);
end;

function TBrickMaster.IsChibiPresent: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_CHIBI_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetChibiAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiMasterAddress(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_MASTER_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiMasterAddress: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_MASTER_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiSlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiSlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetChibiSignalStrength: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_SIGNAL_STRENGTH, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.GetChibiErrorLog(out underrun: word; out crcError: word; out noAck: word; out overflow: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_ERROR_LOG, response);
  underrun := LEConvertUInt16From(4, response);
  crcError := LEConvertUInt16From(6, response);
  noAck := LEConvertUInt16From(8, response);
  overflow := LEConvertUInt16From(10, response);
end;

procedure TBrickMaster.SetChibiFrequency(const frequency: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_FREQUENCY, 5);
  LEConvertUInt8To(frequency, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiFrequency: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_FREQUENCY, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetChibiChannel(const channel: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_CHIBI_CHANNEL, 5);
  LEConvertUInt8To(channel, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChibiChannel: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIBI_CHANNEL, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.IsRS485Present: boolean;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_IS_RS485_PRESENT, response);
  result := LEConvertBooleanFrom(4, response);
end;

procedure TBrickMaster.SetRS485Address(const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_ADDRESS, 5);
  LEConvertUInt8To(address, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485Address: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickMaster.SetRS485SlaveAddress(const num: byte; const address: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_SLAVE_ADDRESS, 6);
  LEConvertUInt8To(num, 4, request);
  LEConvertUInt8To(address, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetRS485SlaveAddress(const num: byte): byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, 5);
  LEConvertUInt8To(num, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_SLAVE_ADDRESS, response);
  result := LEConvertUInt8From(4, response);
end;

function TBrickMaster.GetRS485ErrorLog: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_ERROR_LOG, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickMaster.SetRS485Configuration(const speed: longword; const parity: char; const stopbits: byte);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_SET_RS485_CONFIGURATION, 10);
  LEConvertUInt32To(speed, 4, request);
  LEConvertCharTo(parity, 8, request);
  LEConvertUInt8To(stopbits, 9, request);
  SendRequestNoResponse(request);
end;

procedure TBrickMaster.GetRS485Configuration(out speed: longword; out parity: char; out stopbits: byte);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_RS485_CONFIGURATION, response);
  speed := LEConvertUInt32From(4, response);
  parity := LEConvertCharFrom(8, response);
  stopbits := LEConvertUInt8From(9, response);
end;

procedure TBrickMaster.Reset;
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_RESET, 4);
  SendRequestNoResponse(request);
end;

function TBrickMaster.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICK_MASTER_FUNCTION_GET_CHIP_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

end.
