{
  This file was automatically generated on 2012-07-25.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletAnalogIn;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE = 1;
  BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_ANALOG_IN_FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 3;
  BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 4;
  BRICKLET_ANALOG_IN_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
  BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
  BRICKLET_ANALOG_IN_FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 7;
  BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 8;
  BRICKLET_ANALOG_IN_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
  BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
  BRICKLET_ANALOG_IN_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_ANALOG_IN_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_ANALOG_IN_CALLBACK_VOLTAGE = 13;
  BRICKLET_ANALOG_IN_CALLBACK_ANALOG_VALUE = 14;
  BRICKLET_ANALOG_IN_CALLBACK_VOLTAGE_REACHED = 15;
  BRICKLET_ANALOG_IN_CALLBACK_ANALOG_VALUE_REACHED = 16;

type
  TBrickletAnalogInNotifyVoltage = procedure(const voltage: word) of object;
  TBrickletAnalogInNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletAnalogInNotifyVoltageReached = procedure(const voltage: word) of object;
  TBrickletAnalogInNotifyAnalogValueReached = procedure(const value: word) of object;

  TBrickletAnalogIn = class(TDevice)
  private
    voltageCallback: TBrickletAnalogInNotifyVoltage;
    analogValueCallback: TBrickletAnalogInNotifyAnalogValue;
    voltageReachedCallback: TBrickletAnalogInNotifyVoltageReached;
    analogValueReachedCallback: TBrickletAnalogInNotifyAnalogValueReached;
    procedure CallbackWrapperVoltage(const packet: TByteArray);
    procedure CallbackWrapperAnalogValue(const packet: TByteArray);
    procedure CallbackWrapperVoltageReached(const packet: TByteArray);
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray);
  public
    constructor Create(const uid_: string);
    function GetVoltage: word; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetVoltageCallbackPeriod(const period: longword); virtual;
    function GetVoltageCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetVoltageCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetVoltageCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnVoltage: TBrickletAnalogInNotifyVoltage read voltageCallback write voltageCallback;
    property OnAnalogValue: TBrickletAnalogInNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnVoltageReached: TBrickletAnalogInNotifyVoltageReached read voltageReachedCallback write voltageReachedCallback;
    property OnAnalogValueReached: TBrickletAnalogInNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletAnalogIn.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Analog In Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_ANALOG_IN_CALLBACK_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperVoltage;
  callbackWrappers[BRICKLET_ANALOG_IN_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_ANALOG_IN_CALLBACK_VOLTAGE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVoltageReached;
  callbackWrappers[BRICKLET_ANALOG_IN_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletAnalogIn.GetVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickletAnalogIn.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletAnalogIn.SetVoltageCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAnalogIn.GetVoltageCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAnalogIn.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAnalogIn.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAnalogIn.SetVoltageCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletAnalogIn.GetVoltageCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletAnalogIn.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletAnalogIn.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletAnalogIn.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletAnalogIn.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_ANALOG_IN_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_ANALOG_IN_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletAnalogIn.CallbackWrapperVoltage(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(voltageCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    voltageCallback(voltage);
  end;
end;

procedure TBrickletAnalogIn.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletAnalogIn.CallbackWrapperVoltageReached(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(voltageReachedCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    voltageReachedCallback(voltage);
  end;
end;

procedure TBrickletAnalogIn.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
