{
  This file was automatically generated on 2012-07-25.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletDistanceIR;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE = 1;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_SAMPLING_POINT = 3;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_SAMPLING_POINT = 4;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 5;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 6;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 7;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 8;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 9;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 10;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 11;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 12;
  BRICKLET_DISTANCE_IR_FUNCTION_SET_DEBOUNCE_PERIOD = 13;
  BRICKLET_DISTANCE_IR_FUNCTION_GET_DEBOUNCE_PERIOD = 14;
  BRICKLET_DISTANCE_IR_CALLBACK_DISTANCE = 15;
  BRICKLET_DISTANCE_IR_CALLBACK_ANALOG_VALUE = 16;
  BRICKLET_DISTANCE_IR_CALLBACK_DISTANCE_REACHED = 17;
  BRICKLET_DISTANCE_IR_CALLBACK_ANALOG_VALUE_REACHED = 18;

type
  TBrickletDistanceIRNotifyDistance = procedure(const distance: word) of object;
  TBrickletDistanceIRNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletDistanceIRNotifyDistanceReached = procedure(const distance: word) of object;
  TBrickletDistanceIRNotifyAnalogValueReached = procedure(const value: word) of object;

  TBrickletDistanceIR = class(TDevice)
  private
    distanceCallback: TBrickletDistanceIRNotifyDistance;
    analogValueCallback: TBrickletDistanceIRNotifyAnalogValue;
    distanceReachedCallback: TBrickletDistanceIRNotifyDistanceReached;
    analogValueReachedCallback: TBrickletDistanceIRNotifyAnalogValueReached;
    procedure CallbackWrapperDistance(const packet: TByteArray);
    procedure CallbackWrapperAnalogValue(const packet: TByteArray);
    procedure CallbackWrapperDistanceReached(const packet: TByteArray);
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray);
  public
    constructor Create(const uid_: string);
    function GetDistance: word; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetSamplingPoint(const position: byte; const distance: word); virtual;
    function GetSamplingPoint(const position: byte): word; virtual;
    procedure SetDistanceCallbackPeriod(const period: longword); virtual;
    function GetDistanceCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetDistanceCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetDistanceCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnDistance: TBrickletDistanceIRNotifyDistance read distanceCallback write distanceCallback;
    property OnAnalogValue: TBrickletDistanceIRNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnDistanceReached: TBrickletDistanceIRNotifyDistanceReached read distanceReachedCallback write distanceReachedCallback;
    property OnAnalogValueReached: TBrickletDistanceIRNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletDistanceIR.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Distance IR Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_DISTANCE_IR_CALLBACK_DISTANCE] := {$ifdef FPC}@{$endif}CallbackWrapperDistance;
  callbackWrappers[BRICKLET_DISTANCE_IR_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_DISTANCE_IR_CALLBACK_DISTANCE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperDistanceReached;
  callbackWrappers[BRICKLET_DISTANCE_IR_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletDistanceIR.GetDistance: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickletDistanceIR.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletDistanceIR.SetSamplingPoint(const position: byte; const distance: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_SAMPLING_POINT, 7);
  LEConvertUInt8To(position, 4, request);
  LEConvertUInt16To(distance, 5, request);
  SendRequestNoResponse(request);
end;

function TBrickletDistanceIR.GetSamplingPoint(const position: byte): word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_SAMPLING_POINT, 5);
  LEConvertUInt8To(position, 4, request);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_SAMPLING_POINT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletDistanceIR.SetDistanceCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletDistanceIR.GetDistanceCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletDistanceIR.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletDistanceIR.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletDistanceIR.SetDistanceCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletDistanceIR.GetDistanceCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletDistanceIR.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletDistanceIR.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletDistanceIR.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletDistanceIR.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_DISTANCE_IR_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_DISTANCE_IR_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletDistanceIR.CallbackWrapperDistance(const packet: TByteArray);
var distance: word;
begin
  if (Assigned(distanceCallback)) then begin
    distance := LEConvertUInt16From(4, packet);
    distanceCallback(distance);
  end;
end;

procedure TBrickletDistanceIR.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletDistanceIR.CallbackWrapperDistanceReached(const packet: TByteArray);
var distance: word;
begin
  if (Assigned(distanceReachedCallback)) then begin
    distance := LEConvertUInt16From(4, packet);
    distanceReachedCallback(distance);
  end;
end;

procedure TBrickletDistanceIR.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
