{
  This file was automatically generated on 2012-07-25.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletTemperatureIR;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE = 1;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE = 2;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_EMISSIVITY = 3;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_EMISSIVITY = 4;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 5;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD = 6;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 7;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD = 8;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 9;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD = 10;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 11;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD = 12;
  BRICKLET_TEMPERATURE_IR_FUNCTION_SET_DEBOUNCE_PERIOD = 13;
  BRICKLET_TEMPERATURE_IR_FUNCTION_GET_DEBOUNCE_PERIOD = 14;
  BRICKLET_TEMPERATURE_IR_CALLBACK_AMBIENT_TEMPERATURE = 15;
  BRICKLET_TEMPERATURE_IR_CALLBACK_OBJECT_TEMPERATURE = 16;
  BRICKLET_TEMPERATURE_IR_CALLBACK_AMBIENT_TEMPERATURE_REACHED = 17;
  BRICKLET_TEMPERATURE_IR_CALLBACK_OBJECT_TEMPERATURE_REACHED = 18;

type
  TBrickletTemperatureIRNotifyAmbientTemperature = procedure(const temperature: smallint) of object;
  TBrickletTemperatureIRNotifyObjectTemperature = procedure(const temperature: smallint) of object;
  TBrickletTemperatureIRNotifyAmbientTemperatureReached = procedure(const temperature: smallint) of object;
  TBrickletTemperatureIRNotifyObjectTemperatureReached = procedure(const temperature: smallint) of object;

  TBrickletTemperatureIR = class(TDevice)
  private
    ambientTemperatureCallback: TBrickletTemperatureIRNotifyAmbientTemperature;
    objectTemperatureCallback: TBrickletTemperatureIRNotifyObjectTemperature;
    ambientTemperatureReachedCallback: TBrickletTemperatureIRNotifyAmbientTemperatureReached;
    objectTemperatureReachedCallback: TBrickletTemperatureIRNotifyObjectTemperatureReached;
    procedure CallbackWrapperAmbientTemperature(const packet: TByteArray);
    procedure CallbackWrapperObjectTemperature(const packet: TByteArray);
    procedure CallbackWrapperAmbientTemperatureReached(const packet: TByteArray);
    procedure CallbackWrapperObjectTemperatureReached(const packet: TByteArray);
  public
    constructor Create(const uid_: string);
    function GetAmbientTemperature: smallint; virtual;
    function GetObjectTemperature: smallint; virtual;
    procedure SetEmissivity(const emissivity: word); virtual;
    function GetEmissivity: word; virtual;
    procedure SetAmbientTemperatureCallbackPeriod(const period: longword); virtual;
    function GetAmbientTemperatureCallbackPeriod: longword; virtual;
    procedure SetObjectTemperatureCallbackPeriod(const period: longword); virtual;
    function GetObjectTemperatureCallbackPeriod: longword; virtual;
    procedure SetAmbientTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetAmbientTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetObjectTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetObjectTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnAmbientTemperature: TBrickletTemperatureIRNotifyAmbientTemperature read ambientTemperatureCallback write ambientTemperatureCallback;
    property OnObjectTemperature: TBrickletTemperatureIRNotifyObjectTemperature read objectTemperatureCallback write objectTemperatureCallback;
    property OnAmbientTemperatureReached: TBrickletTemperatureIRNotifyAmbientTemperatureReached read ambientTemperatureReachedCallback write ambientTemperatureReachedCallback;
    property OnObjectTemperatureReached: TBrickletTemperatureIRNotifyObjectTemperatureReached read objectTemperatureReachedCallback write objectTemperatureReachedCallback;
  end;

implementation

constructor TBrickletTemperatureIR.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Temperature IR Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_TEMPERATURE_IR_CALLBACK_AMBIENT_TEMPERATURE] := {$ifdef FPC}@{$endif}CallbackWrapperAmbientTemperature;
  callbackWrappers[BRICKLET_TEMPERATURE_IR_CALLBACK_OBJECT_TEMPERATURE] := {$ifdef FPC}@{$endif}CallbackWrapperObjectTemperature;
  callbackWrappers[BRICKLET_TEMPERATURE_IR_CALLBACK_AMBIENT_TEMPERATURE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAmbientTemperatureReached;
  callbackWrappers[BRICKLET_TEMPERATURE_IR_CALLBACK_OBJECT_TEMPERATURE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperObjectTemperatureReached;
end;

function TBrickletTemperatureIR.GetAmbientTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

function TBrickletTemperatureIR.GetObjectTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickletTemperatureIR.SetEmissivity(const emissivity: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_EMISSIVITY, 6);
  LEConvertUInt16To(emissivity, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperatureIR.GetEmissivity: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_EMISSIVITY, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_EMISSIVITY, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletTemperatureIR.SetAmbientTemperatureCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperatureIR.GetAmbientTemperatureCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletTemperatureIR.SetObjectTemperatureCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperatureIR.GetObjectTemperatureCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletTemperatureIR.SetAmbientTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletTemperatureIR.GetAmbientTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_AMBIENT_TEMPERATURE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletTemperatureIR.SetObjectTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletTemperatureIR.GetObjectTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_OBJECT_TEMPERATURE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletTemperatureIR.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperatureIR.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_IR_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletTemperatureIR.CallbackWrapperAmbientTemperature(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(ambientTemperatureCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    ambientTemperatureCallback(temperature);
  end;
end;

procedure TBrickletTemperatureIR.CallbackWrapperObjectTemperature(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(objectTemperatureCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    objectTemperatureCallback(temperature);
  end;
end;

procedure TBrickletTemperatureIR.CallbackWrapperAmbientTemperatureReached(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(ambientTemperatureReachedCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    ambientTemperatureReachedCallback(temperature);
  end;
end;

procedure TBrickletTemperatureIR.CallbackWrapperObjectTemperatureReached(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(objectTemperatureReachedCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    objectTemperatureReachedCallback(temperature);
  end;
end;

end.
